% Funzione che definisce accelerazioni, dati magnetici, temperature, date e
% livello della batteria per i nodi di tipo Klino Link
function [TimeKLHR,ang_KLHR,temp_KLHR,ErrKlinoLinkHR] = defDatiKLHR(...
    DatiKlinoLinkHR,ErrKlinoLinkHR,Ndatidespike,rKLHR,NodoKlinoLinkHR,...
    NuovoZeroKLHR,IDcentralina,DTcatena,FileName)

fileID = fopen(FileName,'a');
fmt = '%s \r';
text = 'defDatiKLHR function started';
fprintf(fileID,fmt,text);

[r,c]=size(DatiKlinoLinkHR);
Ncorr = 0;
% Elimino gli eventuali Not a Number
for a = 2:r
    for b = 1:c
        check = isnan(DatiKlinoLinkHR(a,b));
        if check == 1
            DatiKlinoLinkHR(a,b) = DatiKlinoLinkHR(a-1,b);
            ErrKlinoLinkHR(a,b-1) = 1;
            Ncorr = Ncorr+1;
        end
    end
end

text = [num2str(Ncorr) ' NaN of Klino Link HR corrected by defDatiKL function'];
fprintf(fileID,fmt,text);

[r,~]=size(DatiKlinoLinkHR);
TimeKLHR = DatiKlinoLinkHR(:,1); % data
ang_KLHR = zeros(r,rKLHR*2); % dati angoli
temp_KLHR = zeros(r,rKLHR); % temperatura del nodo per la calibrazione
p = 2; % passo
s = 1;
ctl = 1;
if strcmp(NodoKlinoLinkHR(1,4),'IPTM') == 1
    for i = 1:rKLHR
        ang_KLHR(:,s:s+1) = DatiKlinoLinkHR(:,p:p+1);
        s = s+2;
        temp_KLHR(:,i) = DatiKlinoLinkHR(:,p+2);
        p = p+3;
    end
else
    for i = 1:rKLHR
        ang_KLHR(:,s:s+1) = DatiKlinoLinkHR(:,p:p+1);
        s = s+2;
        controllo_KLHR(:,ctl:ctl+2) = DatiKlinoLinkHR(:,p+2:p+4);
        ctl = ctl+3;
        temp_KLHR(:,i) = DatiKlinoLinkHR(:,p+5);
        p = p+6;
    end
end

s = 1;
Num_Dati = Ndatidespike; % numero di dati per il despike
if Num_Dati > r
    Num_Dati = r;
end
for i = 1:rKLHR
    % despiking
    ang_KLHR(1:end-1,s) = filloutliers(ang_KLHR(1:end-1,s),'linear','movmedian',Num_Dati);    
    ang_KLHR(1:end-1,s+1) = filloutliers(ang_KLHR(1:end-1,s+1),'linear','movmedian',Num_Dati);     
    s = s+2;
end

[rC,cC] = size(ang_KLHR);
AmpolleUpdate = ['' IDcentralina '-' DTcatena '-Ampolle.csv'];
if strcmp(NodoKlinoLinkHR(1,4),'IPTM') == 1
else
    if NuovoZeroKLHR == 1
        %% !!! Controllo che le ampolle non siano fuori scala (32768)
        Dati = csvread(AmpolleUpdate);
        Dati(:,1) = Dati(:,1) + 730000;
        [rD,~] = size(Dati);
        if rD ~= 0
            for j = 1:rC
                for ii = 1:cC
                    segno1 = 0;
                    if j == 1
                        for a = 2:rD
                            if TimeKLHR(j,1) == Dati(a,1)
                                segno1 = sign(Dati(a-1,ii+1)); % segno del valore alla data precedente
                                break
                            end
                        end
                    end
                    if segno1 == 0
                        if j == 1
                        else
                            segno1 = sign(ang_KLHR(j-1,ii)); % segno del valore alla data precedente
                        end
                    end
                    segno2 = sign(ang_KLHR(j,ii)); % segno del valore alla data successiva
                    if segno2 ~= segno1 % se i due segni sono diversi
                        if abs(ang_KLHR(j,ii)) > 15000
                            if segno1 == 1
                                ang_KLHR(j,ii) = 32768 + (32768 + ang_KLHR(j,ii)); % Fondo scala positivo
                            elseif segno1 == -1
                                ang_KLHR(j,ii) = -32768 + (-32768 + ang_KLHR(j,ii)); % Fondo scala negativo
                            end
                            text = ['Klino Link was out of range on node ' NodoKlinoLinkHR(ii/2,2) ''];
                            fprintf(fileID,fmt,text);
                        end
                    end
                end
            end
            indice = 1;
            for j=1:rC
                if Dati(end,1) == TimeKLHR(j,1)
                    indice = j+1;
                    break
                end
            end
        else
            indice = 1;
        end
    else
        indice = 1;
    end
    
    %% Controllo che l'ampolla non venga letta come MEMS!
    index = 1;
    nodo = 1;
    for b = 1:rKLHR % nodi
        for a = 1:rC % date
            if controllo_KLHR(a,index)~=0 && controllo_KLHR(a,index+1)~=0 && controllo_KLHR(a,index+2)~=0
                if a == 1
                    if NuovoZeroKLHR == 1
                        for aa = 2:rD
                            if TimeKLHR(a,1) == Dati(aa,1)
                                ang_KLHR(a,2*nodo-1:2*nodo) =  Dati(aa-1,2*nodo:2*nodo+1); % valore alla data precedente
                                break
                            end
                        end
                    end
                else
                    ang_KLHR(a,2*nodo-1:2*nodo) = ang_KLHR(a-1,2*nodo-1:2*nodo);
                end
                ErrKlinoLinkHR(a,2*nodo-1:2*nodo) = 1;
            end
        end
        index = index+3;
        nodo = nodo+1;
    end
    Dati = TimeKLHR(indice:end,1);
    Dati(:,1) = Dati(:,1) - 730000;
    datiHR = [Dati(:,1) ang_KLHR(indice:end,:)];
    dat=isempty(datiHR);
    if dat==0
        if NuovoZeroKLHR == 1
            delete(AmpolleUpdate);
        end
        csvwrite(AmpolleUpdate,datiHR);
    end
end

text = 'Data of Klino Link HR defined correctly. defDatiKLHR function closed';
fprintf(fileID,fmt,text);
fclose(fileID);

end
